/**
 * inversify v.2.0.0-alpha.5 - A lightweight IoC container written in TypeScript.
 * Copyright (c) 2015 Remo H. Jansen
 * MIT inversify.io/LICENSE
 * http://inversify.io
 */
(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.inversify = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
function tagParameter(target, targetKey, index, metadata) {
    var metadataKey = "inversify:tagged";
    var paramsMetadata = null;
    if (targetKey !== undefined) {
        var msg = "The @tagged and @named decorator must be applied to the parameters of a constructor.";
        throw new Error(msg);
    }
    if (Reflect.hasOwnMetadata(metadataKey, target) !== true) {
        paramsMetadata = {};
    }
    else {
        paramsMetadata = Reflect.getMetadata(metadataKey, target);
    }
    var paramMetadata = paramsMetadata[index.toString()];
    if (Array.isArray(paramMetadata) !== true) {
        paramMetadata = [];
    }
    else {
        for (var i = 0; i < paramMetadata.length; i++) {
            var m = paramMetadata[i];
            if (m.key === metadata.key) {
                throw new Error("Metadadata key " + m.key + " was used more than once in a parameter.");
            }
        }
    }
    paramMetadata.push(metadata);
    paramsMetadata[index.toString()] = paramMetadata;
    Reflect.defineMetadata(metadataKey, paramsMetadata, target);
    return target;
}
exports.tagParameter = tagParameter;
function _decorate(decorators, target) {
    Reflect.decorate(decorators, target);
}
function _param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); };
}
function decorate(decorator, target, parameterIndex) {
    if (typeof parameterIndex === "number") {
        _decorate([_param(parameterIndex, decorator)], target);
    }
    else {
        _decorate([decorator], target);
    }
}
exports.decorate = decorate;

},{}],2:[function(require,module,exports){
"use strict";
var METADATA_KEY = require("../constants/metadata_keys");
var ERRORS_MSGS = require("../constants/error_msgs");
function inject() {
    var paramTypes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paramTypes[_i - 0] = arguments[_i];
    }
    return function (target) {
        if (Reflect.hasOwnMetadata(METADATA_KEY.INJECT, target) === true) {
            throw new Error(ERRORS_MSGS.DUPLICATED_INJECT_DECORATOR);
        }
        Reflect.defineMetadata(METADATA_KEY.INJECT, paramTypes, target);
        return target;
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = inject;

},{"../constants/error_msgs":11,"../constants/metadata_keys":12}],3:[function(require,module,exports){
"use strict";
var Metadata = (function () {
    function Metadata(key, value) {
        this.key = key;
        this.value = value;
    }
    return Metadata;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Metadata;

},{}],4:[function(require,module,exports){
"use strict";
var metadata_1 = require("../activation/metadata");
var decorator_utils_1 = require("./decorator_utils");
function named(name) {
    return function (target, targetKey, index) {
        var metadata = new metadata_1.default("named", name);
        return decorator_utils_1.tagParameter(target, targetKey, index, metadata);
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = named;

},{"../activation/metadata":3,"./decorator_utils":1}],5:[function(require,module,exports){
"use strict";
var METADATA_KEY = require("../constants/metadata_keys");
var ERRORS_MSGS = require("../constants/error_msgs");
function paramNames() {
    var names = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        names[_i - 0] = arguments[_i];
    }
    return function (target) {
        if (Reflect.hasOwnMetadata(METADATA_KEY.PARAM_NAMES, target) === true) {
            throw new Error(ERRORS_MSGS.DUPLICATED_PARAM_NAMES_DECORATOR);
        }
        Reflect.defineMetadata(METADATA_KEY.PARAM_NAMES, names, target);
        return target;
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = paramNames;

},{"../constants/error_msgs":11,"../constants/metadata_keys":12}],6:[function(require,module,exports){
"use strict";
var metadata_1 = require("../activation/metadata");
var decorator_utils_1 = require("./decorator_utils");
function tagged(metadataKey, metadataValue) {
    return function (target, targetKey, index) {
        var metadata = new metadata_1.default(metadataKey, metadataValue);
        return decorator_utils_1.tagParameter(target, targetKey, index, metadata);
    };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = tagged;

},{"../activation/metadata":3,"./decorator_utils":1}],7:[function(require,module,exports){
"use strict";
var binding_scope_1 = require("./binding_scope");
var binding_type_1 = require("./binding_type");
var Binding = (function () {
    function Binding(runtimeIdentifier) {
        this.activated = false;
        this.runtimeIdentifier = runtimeIdentifier;
        this.scope = binding_scope_1.default.Transient;
        this.type = binding_type_1.default.Invalid;
        this.constraint = function (request) { return true; };
        this.implementationType = null;
        this.cache = null;
        this.factory = null;
        this.provider = null;
        this.proxyMaker = null;
    }
    return Binding;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Binding;

},{"./binding_scope":9,"./binding_type":10}],8:[function(require,module,exports){
"use strict";
var BindingCount;
(function (BindingCount) {
    BindingCount[BindingCount["NoBindingsAvailable"] = 0] = "NoBindingsAvailable";
    BindingCount[BindingCount["OnlyOneBindingAvailable"] = 1] = "OnlyOneBindingAvailable";
    BindingCount[BindingCount["MultipleBindingsAvailable"] = 2] = "MultipleBindingsAvailable";
})(BindingCount || (BindingCount = {}));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = BindingCount;

},{}],9:[function(require,module,exports){
"use strict";
var BindingScope;
(function (BindingScope) {
    BindingScope[BindingScope["Transient"] = 0] = "Transient";
    BindingScope[BindingScope["Singleton"] = 1] = "Singleton";
})(BindingScope || (BindingScope = {}));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = BindingScope;

},{}],10:[function(require,module,exports){
"use strict";
var BindingType;
(function (BindingType) {
    BindingType[BindingType["Invalid"] = 0] = "Invalid";
    BindingType[BindingType["Instance"] = 1] = "Instance";
    BindingType[BindingType["Value"] = 2] = "Value";
    BindingType[BindingType["Constructor"] = 3] = "Constructor";
    BindingType[BindingType["Factory"] = 4] = "Factory";
    BindingType[BindingType["Provider"] = 5] = "Provider";
})(BindingType || (BindingType = {}));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = BindingType;

},{}],11:[function(require,module,exports){
"use strict";
exports.DUPLICATED_INJECT_DECORATOR = "Cannot apply @Inject decorator multiple times.";
exports.DUPLICATED_PARAM_NAMES_DECORATOR = "Cannot apply @paramNames decorator multiple times.";
exports.NULL_ARGUMENT = "NULL argument";
exports.KEY_NOT_FOUND = "Key Not Found";
exports.AMBIGUOUS_MATCH = "Ambiguous match found for service:";
exports.CANNOT_UNBIND = "Could not unbind service:";
exports.NOT_REGISTERED = "No bindigns found for service:";
exports.CIRCULAR_DEPENDENCY = "Circular dependency found between services:";
exports.NOT_IMPLEMENTED = "Sorry, this feature is not fully implemented yet.";
exports.INVALID_BINDING_TYPE = "Invalid binding type:";

},{}],12:[function(require,module,exports){
"use strict";
exports.TAGGED = "inversify:tagged";
exports.INJECT = "inversify:inject";
exports.PARAM_NAMES = "inversify:param_names";

},{}],13:[function(require,module,exports){
"use strict";
var kernel_1 = require("./kernel/kernel");
exports.Kernel = kernel_1.default;
var inject_1 = require("./activation/inject");
exports.inject = inject_1.default;
var tagged_1 = require("./activation/tagged");
exports.tagged = tagged_1.default;
var named_1 = require("./activation/named");
exports.named = named_1.default;
var paramnames_1 = require("./activation/paramnames");
exports.paramNames = paramnames_1.default;
var decorator_utils_1 = require("./activation/decorator_utils");
exports.decorate = decorator_utils_1.decorate;

},{"./activation/decorator_utils":1,"./activation/inject":2,"./activation/named":4,"./activation/paramnames":5,"./activation/tagged":6,"./kernel/kernel":14}],14:[function(require,module,exports){
"use strict";
var binding_count_1 = require("../bindings/binding_count");
var binding_1 = require("../bindings/binding");
var lookup_1 = require("./lookup");
var planner_1 = require("../planning/planner");
var resolver_1 = require("../resolution/resolver");
var ERROR_MSGS = require("../constants/error_msgs");
var binding_to_syntax_1 = require("../syntax/binding_to_syntax");
var Kernel = (function () {
    function Kernel(options) {
        var _this = this;
        if (options === void 0) { options = { middleware: [], modules: [] }; }
        this._planner = new planner_1.default();
        this._resolver = new resolver_1.default(options.middleware);
        this._bindingDictionary = new lookup_1.default();
        if (Array.isArray(options.modules) === true) {
            options.modules.forEach(function (module) { module(_this); });
        }
    }
    Kernel.prototype.bind = function (runtimeIdentifier) {
        var binding = new binding_1.default(runtimeIdentifier);
        this._bindingDictionary.add(runtimeIdentifier, binding);
        return new binding_to_syntax_1.default(binding);
    };
    Kernel.prototype.unbind = function (runtimeIdentifier) {
        try {
            this._bindingDictionary.remove(runtimeIdentifier);
        }
        catch (e) {
            throw new Error(ERROR_MSGS.CANNOT_UNBIND + " " + runtimeIdentifier);
        }
    };
    Kernel.prototype.unbindAll = function () {
        this._bindingDictionary = new lookup_1.default();
    };
    Kernel.prototype.get = function (runtimeIdentifier) {
        var bindings = this._planner.getBindings(this, runtimeIdentifier);
        switch (bindings.length) {
            case binding_count_1.default.NoBindingsAvailable:
                throw new Error(ERROR_MSGS.NOT_REGISTERED + " " + runtimeIdentifier);
            case binding_count_1.default.OnlyOneBindingAvailable:
                return this._planAndResolve(bindings[0]);
            case binding_count_1.default.MultipleBindingsAvailable:
            default:
                throw new Error(ERROR_MSGS.AMBIGUOUS_MATCH + " " + runtimeIdentifier);
        }
    };
    Kernel.prototype.getAll = function (runtimeIdentifier) {
        var _this = this;
        var bindings = this._planner.getBindings(this, runtimeIdentifier);
        switch (bindings.length) {
            case binding_count_1.default.NoBindingsAvailable:
                throw new Error(ERROR_MSGS.NOT_REGISTERED + " " + runtimeIdentifier);
            case binding_count_1.default.OnlyOneBindingAvailable:
            case binding_count_1.default.MultipleBindingsAvailable:
            default:
                return bindings.map(function (binding) {
                    return _this._planAndResolve(binding);
                });
        }
    };
    Kernel.prototype._planAndResolve = function (binding) {
        var context = this._planner.createContext(this);
        this._planner.createPlan(context, binding);
        return this._resolver.resolve(context);
    };
    return Kernel;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Kernel;

},{"../bindings/binding":7,"../bindings/binding_count":8,"../constants/error_msgs":11,"../planning/planner":19,"../resolution/resolver":23,"../syntax/binding_to_syntax":25,"./lookup":16}],15:[function(require,module,exports){
"use strict";
var KeyValuePair = (function () {
    function KeyValuePair(key, value) {
        this.key = key;
        this.value = new Array();
        this.value.push(value);
    }
    return KeyValuePair;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = KeyValuePair;

},{}],16:[function(require,module,exports){
"use strict";
var key_value_pair_1 = require("./key_value_pair");
var ERROR_MSGS = require("../constants/error_msgs");
var Lookup = (function () {
    function Lookup() {
        this._dictionary = new Array();
    }
    Lookup.prototype.add = function (key, value) {
        if (key === null || key === undefined) {
            throw new Error(ERROR_MSGS.NULL_ARGUMENT);
        }
        ;
        if (value === null || value === undefined) {
            throw new Error(ERROR_MSGS.NULL_ARGUMENT);
        }
        ;
        var index = this.getIndexByKey(key);
        if (index !== -1) {
            this._dictionary[index].value.push(value);
        }
        else {
            this._dictionary.push(new key_value_pair_1.default(key, value));
        }
    };
    Lookup.prototype.get = function (key) {
        if (key === null || key === undefined) {
            throw new Error(ERROR_MSGS.NULL_ARGUMENT);
        }
        var index = this.getIndexByKey(key);
        if (index !== -1) {
            return this._dictionary[index].value;
        }
        else {
            throw new Error(ERROR_MSGS.KEY_NOT_FOUND);
        }
    };
    Lookup.prototype.remove = function (key) {
        if (key === null || key === undefined) {
            throw new Error(ERROR_MSGS.NULL_ARGUMENT);
        }
        var index = this.getIndexByKey(key);
        if (index !== -1) {
            this._dictionary.splice(index, 1);
        }
        else {
            throw new Error(ERROR_MSGS.KEY_NOT_FOUND);
        }
    };
    Lookup.prototype.hasKey = function (key) {
        if (key === null || key === undefined) {
            throw new Error(ERROR_MSGS.NULL_ARGUMENT);
        }
        var index = this.getIndexByKey(key);
        if (index !== -1) {
            return true;
        }
        else {
            return false;
        }
    };
    Lookup.prototype.getIndexByKey = function (key) {
        var index = -1;
        for (var i = 0; i < this._dictionary.length; i++) {
            var keyValuePair = this._dictionary[i];
            if (keyValuePair.key === key) {
                index = i;
            }
        }
        return index;
    };
    return Lookup;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Lookup;

},{"../constants/error_msgs":11,"./key_value_pair":15}],17:[function(require,module,exports){
"use strict";
var Context = (function () {
    function Context(kernel) {
        this.kernel = kernel;
    }
    Context.prototype.addPlan = function (plan) {
        this.plan = plan;
    };
    return Context;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Context;

},{}],18:[function(require,module,exports){
"use strict";
var Plan = (function () {
    function Plan(parentContext, rootRequest) {
        this.parentContext = parentContext;
        this.rootRequest = rootRequest;
    }
    return Plan;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Plan;

},{}],19:[function(require,module,exports){
"use strict";
var plan_1 = require("./plan");
var context_1 = require("./context");
var request_1 = require("./request");
var target_1 = require("./target");
var METADATA_KEY = require("../constants/metadata_keys");
var ERROR_MSGS = require("../constants/error_msgs");
var binding_type_1 = require("../bindings/binding_type");
var Planner = (function () {
    function Planner() {
    }
    Planner.prototype.createContext = function (kernel) {
        return new context_1.default(kernel);
    };
    Planner.prototype.createPlan = function (context, binding) {
        var _this = this;
        var rootRequest = new request_1.default(binding.runtimeIdentifier, context, null, binding);
        rootRequest.bindings.push(binding);
        var plan = new plan_1.default(context, rootRequest);
        context.addPlan(plan);
        var dependencies = this._getDependencies(binding.implementationType);
        dependencies.forEach(function (target) { _this._createSubRequest(rootRequest, target); });
        return plan;
    };
    Planner.prototype.getBindings = function (kernel, service) {
        var bindings = [];
        var _kernel = kernel;
        var _bindingDictionary = _kernel._bindingDictionary;
        var _service = service.split("[]").join("");
        if (_bindingDictionary.hasKey(_service)) {
            bindings = _bindingDictionary.get(_service);
        }
        return bindings;
    };
    Planner.prototype._createSubRequest = function (parentRequest, target) {
        try {
            var bindings = this.getBindings(parentRequest.parentContext.kernel, target.service.value());
            var activeBindings = [];
            if (bindings.length > 1 && target.isArray() === false) {
                activeBindings = bindings.filter(function (binding) {
                    var request = new request_1.default(binding.runtimeIdentifier, parentRequest.parentContext, parentRequest, binding, target);
                    return binding.constraint(request);
                });
            }
            else {
                activeBindings = bindings;
            }
            if (activeBindings.length === 0) {
                throw new Error(ERROR_MSGS.NOT_REGISTERED + " " + target.service.value());
            }
            else if (activeBindings.length > 1 && target.isArray() === false) {
                throw new Error(ERROR_MSGS.AMBIGUOUS_MATCH + " " + target.service.value());
            }
            else {
                this._createChildRequest(parentRequest, target, activeBindings);
            }
        }
        catch (error) {
            if (error instanceof RangeError) {
                this._throwWhenCircularDependenciesFound(parentRequest.parentContext.plan.rootRequest);
            }
            else {
                throw new Error(error.message);
            }
        }
    };
    Planner.prototype._createChildRequest = function (parentRequest, target, bindings) {
        var _this = this;
        var childRequest = parentRequest.addChildRequest(target.service.value(), bindings, target);
        var subChildRequest = childRequest;
        bindings.forEach(function (binding) {
            if (target.isArray()) {
                subChildRequest = childRequest.addChildRequest(binding.runtimeIdentifier, binding, target);
            }
            if (binding.type === binding_type_1.default.Instance) {
                var subDependencies = _this._getDependencies(binding.implementationType);
                subDependencies.forEach(function (d, index) {
                    _this._createSubRequest(subChildRequest, d);
                });
            }
        });
    };
    Planner.prototype._throwWhenCircularDependenciesFound = function (request, previousServices) {
        var _this = this;
        if (previousServices === void 0) { previousServices = []; }
        previousServices.push(request.service);
        request.childRequests.forEach(function (childRequest) {
            var service = childRequest.service;
            if (previousServices.indexOf(service) === -1) {
                if (childRequest.childRequests.length > 0) {
                    _this._throwWhenCircularDependenciesFound(childRequest, previousServices);
                }
                else {
                    previousServices.push(service);
                }
            }
            else {
                throw new Error(ERROR_MSGS.CIRCULAR_DEPENDENCY + " " + service + " and " + request.service);
            }
        });
    };
    Planner.prototype._getDependencies = function (func) {
        if (func === null) {
            return [];
        }
        var injections = Reflect.getMetadata(METADATA_KEY.INJECT, func) || [];
        var paramNames = Reflect.getMetadata(METADATA_KEY.PARAM_NAMES, func) || [];
        var tags = Reflect.getMetadata(METADATA_KEY.TAGGED, func) || [];
        var targets = injections.map(function (injection, index) {
            var targetName = paramNames[index];
            var target = new target_1.default(targetName, injection);
            target.metadata = tags[index.toString()] || [];
            return target;
        });
        return targets;
    };
    return Planner;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Planner;

},{"../bindings/binding_type":10,"../constants/error_msgs":11,"../constants/metadata_keys":12,"./context":17,"./plan":18,"./request":21,"./target":22}],20:[function(require,module,exports){
"use strict";
var QueryableString = (function () {
    function QueryableString(str) {
        this.str = str;
    }
    QueryableString.prototype.startsWith = function (searchString) {
        return this.str.indexOf(searchString) === 0;
    };
    QueryableString.prototype.endsWith = function (searchString) {
        var reverseString = "";
        var reverseSearchString = searchString.split("").reverse().join("");
        reverseString = this.str.split("").reverse().join("");
        return this.startsWith.call({ str: reverseString }, reverseSearchString);
    };
    QueryableString.prototype.contains = function (searchString) {
        return (this.str.indexOf(searchString) !== -1);
    };
    QueryableString.prototype.equals = function (compareString) {
        return this.str === compareString;
    };
    QueryableString.prototype.value = function () {
        return this.str;
    };
    return QueryableString;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = QueryableString;

},{}],21:[function(require,module,exports){
"use strict";
var Request = (function () {
    function Request(service, parentContext, parentRequest, bindings, target) {
        if (target === void 0) { target = null; }
        this.guid = this._guid();
        this.service = service;
        this.parentContext = parentContext;
        this.parentRequest = parentRequest;
        this.target = target;
        this.childRequests = [];
        this.bindings = (Array.isArray(bindings) ? bindings : ((bindings) ? [bindings] : []));
    }
    Request.prototype.addChildRequest = function (service, bindings, target) {
        var child = new Request(service, this.parentContext, this, bindings, target);
        this.childRequests.push(child);
        return child;
    };
    Request.prototype._s4 = function () {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    };
    Request.prototype._guid = function () {
        return this._s4() + this._s4() + "-" + this._s4() + "-" + this._s4() + "-" +
            this._s4() + "-" + this._s4() + this._s4() + this._s4();
    };
    return Request;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Request;

},{}],22:[function(require,module,exports){
"use strict";
var metadata_1 = require("../activation/metadata");
var queryable_string_1 = require("./queryable_string");
var Target = (function () {
    function Target(name, service, namedOrTagged) {
        this.name = new queryable_string_1.default(name);
        this.service = new queryable_string_1.default(service);
        this.metadata = new Array();
        var metadataItem = null;
        if (typeof namedOrTagged === "string") {
            metadataItem = new metadata_1.default("named", namedOrTagged);
        }
        else if (namedOrTagged instanceof metadata_1.default) {
            metadataItem = namedOrTagged;
        }
        if (metadataItem !== null) {
            this.metadata.push(metadataItem);
        }
    }
    Target.prototype.isArray = function () {
        return (this.service.value().indexOf("[]") !== -1);
    };
    Target.prototype.isNamed = function () {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === "named") {
                return true;
            }
        }
        return false;
    };
    Target.prototype.isTagged = function () {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key !== "named") {
                return true;
            }
        }
        return false;
    };
    Target.prototype.matchesName = function (name) {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === "named" && m.value === name) {
                return true;
            }
        }
        return false;
    };
    Target.prototype.matchesTag = function (metadata) {
        for (var i = 0; i < this.metadata.length; i++) {
            var m = this.metadata[i];
            if (m.key === metadata.key && m.value === metadata.value) {
                return true;
            }
        }
        return false;
    };
    return Target;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Target;

},{"../activation/metadata":3,"./queryable_string":20}],23:[function(require,module,exports){
"use strict";
var binding_scope_1 = require("../bindings/binding_scope");
var binding_type_1 = require("../bindings/binding_type");
var ERROR_MSGS = require("../constants/error_msgs");
var Resolver = (function () {
    function Resolver(middleWare) {
        if (middleWare === void 0) { middleWare = []; }
        this._middleWare = middleWare;
    }
    Resolver.prototype.resolve = function (context) {
        var rootRequest = context.plan.rootRequest;
        return this._inject(rootRequest);
    };
    Resolver.prototype._inject = function (request) {
        var _this = this;
        var bindings = request.bindings;
        var childRequests = request.childRequests;
        if (request.target && request.target.isArray() && bindings.length > 1) {
            return childRequests.map(function (childRequest) { return _this._inject(childRequest); });
        }
        else {
            var result = null;
            var binding = bindings[0];
            var isSingleton = binding.scope === binding_scope_1.default.Singleton;
            if (isSingleton && binding.activated === true) {
                return binding.cache;
            }
            switch (binding.type) {
                case binding_type_1.default.Value:
                    result = binding.cache;
                    break;
                case binding_type_1.default.Constructor:
                    result = binding.implementationType;
                    break;
                case binding_type_1.default.Factory:
                    result = binding.factory(request.parentContext);
                    break;
                case binding_type_1.default.Provider:
                    result = binding.provider(request.parentContext);
                    break;
                case binding_type_1.default.Instance:
                    var constr = binding.implementationType;
                    if (childRequests.length > 0) {
                        var injections = childRequests.map(function (childRequest) {
                            return _this._inject(childRequest);
                        });
                        result = this._createInstance(constr, injections);
                    }
                    else {
                        result = new constr();
                    }
                    break;
                case binding_type_1.default.Invalid:
                default:
                    throw new Error(ERROR_MSGS.INVALID_BINDING_TYPE + " " + request.service);
            }
            if (typeof binding.proxyMaker === "function") {
                result = binding.proxyMaker(result);
            }
            if (isSingleton) {
                binding.cache = result;
                binding.activated = true;
            }
            return result;
        }
    };
    Resolver.prototype._createInstance = function (Func, injections) {
        return new (Func.bind.apply(Func, [void 0].concat(injections)))();
    };
    return Resolver;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Resolver;

},{"../bindings/binding_scope":9,"../bindings/binding_type":10,"../constants/error_msgs":11}],24:[function(require,module,exports){
"use strict";
var binding_scope_1 = require("../bindings/binding_scope");
var metadata_1 = require("../activation/metadata");
var BindingInWhenProxySyntax = (function () {
    function BindingInWhenProxySyntax(binding) {
        this._binding = binding;
    }
    BindingInWhenProxySyntax.prototype.inTransientScope = function () {
        this._binding.scope = binding_scope_1.default.Transient;
        return new BindingInWhenProxySyntax(this._binding);
    };
    BindingInWhenProxySyntax.prototype.inSingletonScope = function () {
        this._binding.scope = binding_scope_1.default.Singleton;
        return new BindingInWhenProxySyntax(this._binding);
    };
    BindingInWhenProxySyntax.prototype.when = function (constraint) {
        this._binding.constraint = constraint;
        return new BindingInWhenProxySyntax(this._binding);
    };
    BindingInWhenProxySyntax.prototype.whenTargetNamed = function (name) {
        this._binding.constraint = function (request) {
            return request.target.matchesName(name);
        };
        return new BindingInWhenProxySyntax(this._binding);
    };
    BindingInWhenProxySyntax.prototype.whenTargetTagged = function (tag, value) {
        this._binding.constraint = function (request) {
            var metadata = new metadata_1.default(tag, value);
            return request.target.matchesTag(metadata);
        };
        return new BindingInWhenProxySyntax(this._binding);
    };
    BindingInWhenProxySyntax.prototype.proxy = function (proxymaker) {
        this._binding.proxyMaker = proxymaker;
        return new BindingInWhenProxySyntax(this._binding);
    };
    return BindingInWhenProxySyntax;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = BindingInWhenProxySyntax;

},{"../activation/metadata":3,"../bindings/binding_scope":9}],25:[function(require,module,exports){
"use strict";
var binding_in_when_proxy_syntax_1 = require("./binding_in_when_proxy_syntax");
var binding_type_1 = require("../bindings/binding_type");
var BindingToSyntax = (function () {
    function BindingToSyntax(binding) {
        this._binding = binding;
    }
    BindingToSyntax.prototype.to = function (constructor) {
        this._binding.type = binding_type_1.default.Instance;
        this._binding.implementationType = constructor;
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    BindingToSyntax.prototype.toValue = function (value) {
        this._binding.type = binding_type_1.default.Value;
        this._binding.cache = value;
        this._binding.implementationType = null;
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    BindingToSyntax.prototype.toConstructor = function (constructor) {
        this._binding.type = binding_type_1.default.Constructor;
        this._binding.implementationType = constructor;
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    BindingToSyntax.prototype.toFactory = function (factory) {
        this._binding.type = binding_type_1.default.Factory;
        this._binding.factory = factory;
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    BindingToSyntax.prototype.toAutoFactory = function () {
        this._binding.type = binding_type_1.default.Factory;
        var id = this._binding.runtimeIdentifier.split("IFactory<").join("").split(">").join("");
        this._binding.factory = function (context) {
            return function () {
                return context.kernel.get(id);
            };
        };
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    BindingToSyntax.prototype.toProvider = function (provider) {
        this._binding.type = binding_type_1.default.Provider;
        this._binding.provider = provider;
        return new binding_in_when_proxy_syntax_1.default(this._binding);
    };
    return BindingToSyntax;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = BindingToSyntax;

},{"../bindings/binding_type":10,"./binding_in_when_proxy_syntax":24}]},{},[13])(13)
});


//# sourceMappingURL=inversify.js.map
